Ainda não tem acesso? Estude com a gente! Matricule-se
Ainda não tem acesso? Estude com a gente! Matricule-se

Solucionado (ver solução)

Sobre Exception

Em meu método Dividir o Exception ex dentro do catch foi sublinhado em verde dizendo que a variável ex foi declarada, mas nunca usada, até ai tudo bem, eu entendi, mas por curiosidade em resolvi declarar ex na frente do throw abaixo, ai pensei, isso seria necessário? poderia ser uma boa prática de programação isto que fiz? Ai o sublinhado sumiu. Fiquei com esta questão na cabeça. Abraços.

public static int Dividir(int numero, int divisor)
        {
            try
            {
                return numero / divisor;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exceção com numero=" + numero + " e divisor=" + divisor);
                throw ex;
            }
        }
1 resposta
solução

Olá Leandro,

A ideia do try, catch é que você dê um tratamento para eventuais exceções que você espera que seu código possa ter.

Utilizando o ex na frente do throw não tem muita diferença de não utilizar, alias é exibido menos informações do que sem o ex, veja que se você forçar um erro, o StackTrace não é exibido quando você declara o ex na frente do throw.

Como no seu caso não tem ninguem pra capturar a exceções lançadas pelo throw, o programa vai quebrar e se você estiver em modo debug, vai ser o Visual Studio apresentar uma Janela com o erro.

De qualquer maneira, o ideal em caso de exceções que não possuem um tratamento especifico (como é o seu caso) é exibir o maximo de detalhes possível:

public static int Dividir(int numero, int divisor)
    {
      try
      {
        return numero / divisor;
      }
      catch (Exception ex)
      {
        Console.WriteLine("Exceção com numero=" + numero + " e divisor=" + divisor);
        Console.WriteLine($"Erro: {ex.Message}");
        Console.WriteLine($"Mais detalhes: {ex.StackTrace}");
        throw ex;
      }
    }